<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="500"
    :visible="visible"
    :confirm-loading="loading"
    :title="isUpdate ? '修改部位' : '新建部位'"
    :body-style="{ paddingBottom: '8px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 6, sm: 6, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 18, sm: 20, xs: 24 } : { flex: '1' }
      "
    >
      <a-row :gutter="16">
        <a-col
          v-bind="styleResponsive ? { md: 22, sm: 24, xs: 24 } : { span: 12 }"
        >
          <a-form-item label="设备名称" name="name">
            <a-input
              allow-clear
              placeholder="请输入设备名称"
              v-model:value="form.name"
              @pressEnter="save"
            />
          </a-form-item>
          <a-form-item label="部位" name="model">
            <a-input
              allow-clear
              placeholder="请输入部位"
              v-model:value="form.model"
              @pressEnter="save"
            />
          </a-form-item>
          <a-form-item label="使用年限" name="yearLife">
            <a-input-number
              :min="0"
              style="width: 200px"
              placeholder="请输入设备使用年限"
              v-model:value="form.yearLife"
            />
            <span class="ml-10">年</span>
          </a-form-item>
        </a-col>
      </a-row>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { message } from 'ant-design-vue/es';
  import type { FormInstance, Rule } from 'ant-design-vue/es/form';
  import { storeToRefs } from 'pinia';
  import { useThemeStore } from '@/store/modules/theme';
  import useFormData from '@/utils/use-form-data';
  import type { TowerModel } from '@/api/tower/model/model';
  import { addTowerModel, updateTowerModel } from '@/api/tower/model';

  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: TowerModel | null;
  }>();

  const formRef = ref<FormInstance | null>(null);
  // 是否是修改
  const isUpdate = ref(false);
  // 提交状态
  const loading = ref(false);

  // 表单数据
  const { form, resetFields, assignFields } = useFormData<TowerModel>({
    name: '',
    modelId: undefined,
    model: undefined,
    image: '',
    status: 0,
    yearLife: undefined,
    sortNumber: 100
  });

  // 表单验证规则
  const rules = reactive<Record<string, Rule[]>>({
    name: [
      {
        required: true,
        message: '请输入设备名称',
        type: 'string',
        trigger: 'blur'
      }
    ],
    model: [
      {
        required: true,
        message: '请输入部位',
        type: 'string',
        trigger: 'blur'
      }
    ],
    yearLife: [
      {
        required: true,
        message: '请输入设备使用年限',
        type: 'number',
        trigger: 'blur'
      }
    ],
    sortNumber: [
      {
        required: true,
        message: '请输入排序号',
        type: 'number',
        trigger: 'blur'
      }
    ]
  });

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const categoryForm = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateTowerModel : addTowerModel;
        saveOrUpdate(categoryForm)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        if (props.data) {
          assignFields({
            ...props.data
          });
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
        formRef.value?.clearValidate();
      }
    }
  );
</script>

<style lang="less">
  .tab-pane {
    min-height: 300px;
  }
  .ml-10 {
    margin-left: 5px;
  }
</style>
